import java.util.*;

public class ArrayStacksIt implements Stack, Iterable {

    private Object[] array;    // Array that holds the Stack
    private int index = 0;     // First empty slot in Stack

    public ArrayStacksIt (int maxSize) {array = new Object[maxSize];}

    public void push (Object x) {array[index++] = x;}
    public Object pop () {return array[--index];}
    public Object peek () {return array[index-1];}
    public boolean isEmpty () {return index == 0;}
    public void makeEmpty () {index = 0;}

	// Anonymous class
	public Iterator iterator() {
		return new Iterator() {
			private int i= index -1;

			public boolean hasNext() {
				return (i!=-1);
			}

			public Object next() {
				Object a= array[i];
				i--;
				return a;
			}

			public void remove() {
				throw new UnsupportedOperationException();
			}

		};
	}
}